| TagLib 1.13 |  |

Public Member Functions | Static Public Member Functions | Protected Member Functions | Friends | List of all members
TagLib::ID3v2::UserUrlLinkFrame Class Reference

ID3v2 User defined URL frame. More...

`#include <urllinkframe.h>`

Inheritance diagram for TagLib::ID3v2::UserUrlLinkFrame:
[legend]
Collaboration diagram for TagLib::ID3v2::UserUrlLinkFrame:
[legend]

## Public Member Functions
| UserUrlLinkFrame (String::Type encoding=String::Latin1)
| UserUrlLinkFrame (const ByteVector &data)
virtual | ~UserUrlLinkFrame ()
virtual String | toString () const
String::Type | textEncoding () const
void | setTextEncoding (String::Type encoding)
String | description () const
void | setDescription (const String &s)
PropertyMap | asProperties () const
Public Member Functions inherited from TagLib::ID3v2::UrlLinkFrame
| UrlLinkFrame (const ByteVector &data)
virtual | ~UrlLinkFrame ()
virtual String | url () const
virtual void | setUrl (const String &s)
virtual void | setText (const String &s)
virtual String | toString () const
PropertyMap | asProperties () const
Public Member Functions inherited from TagLib::ID3v2::Frame
virtual | ~Frame ()
ByteVector | frameID () const
unsigned int | size () const
void | setData (const ByteVector &data)
virtual void | setText (const String &text)
virtual String | toString () const =0
ByteVector | render () const
TAGLIB_DEPRECATED | Header (const ByteVector &data, bool synchSafeInts)
| Header (const ByteVector &data, unsigned int version=4)
virtual | ~Header ()
TAGLIB_DEPRECATED void | setData (const ByteVector &data, bool synchSafeInts)
void | setData (const ByteVector &data, unsigned int version=4)
ByteVector | frameID () const
void | setFrameID (const ByteVector &id)
unsigned int | frameSize () const
void | setFrameSize (unsigned int size)
unsigned int | version () const
void | setVersion (unsigned int version)
bool | tagAlterPreservation () const
void | setTagAlterPreservation (bool discard)
bool | fileAlterPreservation () const
bool | readOnly () const
bool | groupingIdentity () const
bool | compression () const
bool | encryption () const
bool | unsynchronisation () const
bool | dataLengthIndicator () const
ByteVector | render () const
TAGLIB_DEPRECATED bool | frameAlterPreservation () const

## Static Public Member Functions
static UserUrlLinkFrame * | find (Tag *tag, const String &description)
Static Public Member Functions inherited from TagLib::ID3v2::Frame
static Frame * | createTextualFrame (const String &key, const StringList &values)
static unsigned int | headerSize ()
static unsigned int | headerSize (unsigned int version)
static ByteVector | textDelimiter (String::Type t)
static unsigned int | size ()
static unsigned int | size (unsigned int version)

## Protected Member Functions
virtual void | parseFields (const ByteVector &data)
virtual ByteVector | renderFields () const
| UserUrlLinkFrame (const ByteVector &data, Header *h)
Protected Member Functions inherited from TagLib::ID3v2::UrlLinkFrame
virtual void | parseFields (const ByteVector &data)
virtual ByteVector | renderFields () const
| UrlLinkFrame (const ByteVector &data, Header *h)
Protected Member Functions inherited from TagLib::ID3v2::Frame
| Frame (const ByteVector &data)
| Frame (Header *h)
Header * | header () const
void | setHeader (Header *h, bool deleteCurrent=true)
void | parse (const ByteVector &data)
virtual void | parseFields (const ByteVector &data)=0
virtual ByteVector | renderFields () const =0
ByteVector | fieldData (const ByteVector &frameData) const
String | readStringField (const ByteVector &data, String::Type encoding, int *position=0)
String::Type | checkTextEncoding (const StringList &fields, String::Type encoding) const
PropertyMap | asProperties () const

## Friends
class | FrameFactory

## Additional Inherited Members
Static Public Attributes inherited from TagLib::ID3v2::Frame
static const String | instrumentPrefix
static const String | commentPrefix
static const String | lyricsPrefix
static const String | urlPrefix
Static Protected Member Functions inherited from TagLib::ID3v2::Frame
static String::Type | checkEncoding (const StringList &fields, String::Type encoding)
static String::Type | checkEncoding (const StringList &fields, String::Type encoding, unsigned int version)
static ByteVector | keyToFrameID (const String &)
static String | frameIDToKey (const ByteVector &)
static String | keyToTXXX (const String &)
static String | txxxToKey (const String &)
static void | splitProperties (const PropertyMap &original, PropertyMap &singleFrameProperties, PropertyMap &tiplProperties, PropertyMap &tmclProperties)

## Detailed Description

ID3v2 User defined URL frame.

This is a specialization of URL link frames that allows for user defined entries. Each entry has a description in addition to the normal list of fields that a URL link frame has.

This description identifies the frame and must be unique.

## Constructor & Destructor Documentation

## ◆ UserUrlLinkFrame() [1/3]

TagLib::ID3v2::UserUrlLinkFrame::UserUrlLinkFrame | ( | String::Type | encoding = `String::Latin1` | ) |
| explicit

Constructs an empty user defined URL link frame. For this to be a useful frame both a description and text must be set.

## ◆ UserUrlLinkFrame() [2/3]

TagLib::ID3v2::UserUrlLinkFrame::UserUrlLinkFrame | ( | const ByteVector & | data | ) |
| explicit

This is a dual purpose constructor. data can either be binary data that should be parsed or (at a minimum) the frame ID.

## ◆ ~UserUrlLinkFrame()

virtual TagLib::ID3v2::UserUrlLinkFrame::~UserUrlLinkFrame | ( |  | ) |
| virtual

Destroys this UserUrlLinkFrame instance.

## ◆ UserUrlLinkFrame() [3/3]

TagLib::ID3v2::UserUrlLinkFrame::UserUrlLinkFrame | ( | const ByteVector & | data,
|  | Header * | h
| ) |  |
| protected

The constructor used by the FrameFactory.

## Member Function Documentation

## ◆ asProperties()

PropertyMap TagLib::ID3v2::UserUrlLinkFrame::asProperties | ( |  | ) | const

Parses the UserUrlLinkFrame as PropertyMap. The description() is taken as key, and the URL as single value.

- if description() is empty, the key will be "URL".
- otherwise, if description() is not a valid key (e.g. containing non-ASCII characters), the returned map will contain an entry "WXXX/<description>" in its unsupportedData() list.

## ◆ description()

String TagLib::ID3v2::UserUrlLinkFrame::description | ( |  | ) | const

Returns the description for this frame.

## ◆ find()

static UserUrlLinkFrame * TagLib::ID3v2::UserUrlLinkFrame::find | ( | Tag * | tag,
|  | const String & | description
| ) |  |
| static

Searches for the user defined url frame with the description description in tag. This returns null if no matching frames were found.

## ◆ parseFields()

virtual void TagLib::ID3v2::UserUrlLinkFrame::parseFields | ( | const ByteVector & | data | ) |
| protected virtual

Called by parse() to parse the field data. It makes this information available through the public API. This must be overridden by the subclasses.

Reimplemented from TagLib::ID3v2::UrlLinkFrame.

## ◆ renderFields()

virtual ByteVector TagLib::ID3v2::UserUrlLinkFrame::renderFields | ( |  | ) | const
| protected virtual

Render the field data back to a binary format in a ByteVector. This must be overridden by subclasses.

Reimplemented from TagLib::ID3v2::UrlLinkFrame.

## ◆ setDescription()

void TagLib::ID3v2::UserUrlLinkFrame::setDescription | ( | const String & | s | ) |

Sets the description of the frame to s. s must be unique.

## ◆ setTextEncoding()

void TagLib::ID3v2::UserUrlLinkFrame::setTextEncoding | ( | String::Type | encoding | ) |

Sets the text encoding to be used when rendering this frame to encoding.

See also
  textEncoding()
  render()

## ◆ textEncoding()

String::Type TagLib::ID3v2::UserUrlLinkFrame::textEncoding | ( |  | ) | const

Returns the text encoding that will be used in rendering this frame. This defaults to the type that was either specified in the constructor or read from the frame when parsed.

See also
  setTextEncoding()
  render()

## ◆ toString()

virtual String TagLib::ID3v2::UserUrlLinkFrame::toString | ( |  | ) | const
| virtual

This returns the textual representation of the data in the frame. Subclasses must reimplement this method to provide a string representation of the frame's data.

Reimplemented from TagLib::ID3v2::UrlLinkFrame.

## Friends And Related Function Documentation

## ◆ FrameFactory

friend class FrameFactory
| friend

The documentation for this class was generated from the following file:

- urllinkframe.h